unit udbGrid_Transpa;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons, ExtCtrls, Jpeg, Grids, DBGrids, DB;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    Image1: TImage;
    DBGrid1: TDBGrid;
    StringGrid1: TStringGrid;
    bDBGridTranspa: TSpeedButton;
    procedure DBGrid1DrawDataCell(Sender: TObject; const Rect: TRect;
      Field: TField; State: TGridDrawState);
    procedure StringGrid1DrawCell(Sender: TObject; ACol, ARow: Integer;
      Rect: TRect; State: TGridDrawState);
    procedure FormCreate(Sender: TObject);
    procedure bDBGridTranspaClick(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.DBGrid1DrawDataCell(Sender: TObject; const Rect: TRect;
  Field: TField; State: TGridDrawState);
var
  Text: string;
  Rct: TRect;
begin
  Text := 'DBGrid'; //<=  remplacer par Text :=Field.AsString;
  Rct := Rect;

  BitBlt(DBGrid1.Canvas.handle,
    Rct.left,
    Rct.top,
    Rct.right - Rct.left,
    Rct.bottom - Rct.top,
    Image1.Canvas.Handle,
    Rct.left + DBGrid1.Left + Panel1.Left,
    Rct.Top + DBGrid1.Top + Panel1.Top,
    SRCCOPY);

  SetBkModE(DBGrid1.Canvas.Handle, TRANSPARENT);
  DBGrid1.Canvas.Font.Style := [fsBold];
  DBGrid1.Canvas.Font.Color := clRed;
  DrawtextEx(DBGrid1.Canvas.Handle,
    PChar(Text),
    Length(Text),
    Rct,
    DT_WORDBREAK,
    nil);
end;

procedure TForm1.bDBGridTranspaClick(Sender: TObject);
var
  Li, Co: Integer; Recta: TRect; Field: TField; State: TGridDrawState;
begin
  // Pour la DBGrid :
  Li := 1; Co := 1;
  Recta := TDrawGrid(DBGRID1).CellRect(Co - 1, Li - 1);
  State := [gdFixed];
  DBGrid1DrawDataCell(Sender, Recta, Field, State);
  Li := 1; Co := 2;
  Recta := TDrawGrid(DBGRID1).CellRect(Co - 1, Li - 1);
  DBGrid1DrawDataCell(Sender, Recta, Field, State);
  Li := 1; Co := 3;
  Recta := TDrawGrid(DBGRID1).CellRect(Co - 1, Li - 1);
  DBGrid1DrawDataCell(Sender, Recta, Field, State);
  Li := 1; Co := 4;
  Recta := TDrawGrid(DBGRID1).CellRect(Co - 1, Li - 1);
  DBGrid1DrawDataCell(Sender, Recta, Field, State);

  inc(Li); Co := 1;
  Recta := TDrawGrid(DBGRID1).CellRect(Co - 1, Li - 1);
  DBGrid1DrawDataCell(Sender, Recta, Field, State);
  Co := 2;
  Recta := TDrawGrid(DBGRID1).CellRect(Co - 1, Li - 1);
  DBGrid1DrawDataCell(Sender, Recta, Field, State);
  Co := 3;
  Recta := TDrawGrid(DBGRID1).CellRect(Co - 1, Li - 1);
  DBGrid1DrawDataCell(Sender, Recta, Field, State);
  Co := 4;
  Recta := TDrawGrid(DBGRID1).CellRect(Co - 1, Li - 1);
  DBGrid1DrawDataCell(Sender, Recta, Field, State);
end;

procedure TForm1.FormCreate(Sender: TObject);
var
  Li, Co: Integer;
begin
  // Pour la StringGrid :
  with StringGrid1 do
    for Co := 0 to ColCount - 1 do
      for Li := 0 to RowCount - 1 do Cells[Co, Li] := 'StringGrid';
end;

procedure TForm1.StringGrid1DrawCell(Sender: TObject; ACol, ARow: Integer;
  Rect: TRect; State: TGridDrawState);
var
  Text: string;
  Rct: TRect;
begin
  Text := StringGrid1.Cells[ACol, ARow];
  Rct := Rect;

  BitBlt(StringGrid1.Canvas.handle,
    Rct.left,
    Rct.top,
    Rct.right - Rct.left,
    Rct.bottom - Rct.top,
    Image1.Canvas.Handle,
    Rct.left + StringGrid1.Left + Panel1.Left,
    Rct.Top + StringGrid1.Top + Panel1.Top,
    SRCCOPY);

  SetBkModE(StringGrid1.Canvas.Handle, TRANSPARENT);
  StringGrid1.Canvas.Font.Style := [fsBold];
  StringGrid1.Canvas.Font.Color := clRed;
  DrawtextEx(StringGrid1.Canvas.Handle,
    PChar(Text),
    Length(Text),
    Rct,
    DT_WORDBREAK,
    nil);
end;

end.

